﻿using System.Windows;
using System.Windows.Controls;

namespace TestProject
{
    /// <summary>
    /// 마진 UI 엘리먼트 컬렉션
    /// </summary>
    public class MarginUIElementCollection : UIElementCollection
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Field
        ////////////////////////////////////////////////////////////////////////////////////////// Private

        #region Field

        /// <summary>
        /// 커스텀 그리드
        /// </summary>
        private CellPaddingGrid customGrid;

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 생성자 - MarginUIElementCollection(logicalParent)

        /// <summary>
        /// 생성자
        /// </summary>
        /// <param name="logicalParent">논리적 부모</param>
        public MarginUIElementCollection(FrameworkElement logicalParent) : base(logicalParent,null)
        {
            this.customGrid = logicalParent as CellPaddingGrid;
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 추가하기 - Add(element)

        /// <summary>
        /// 추가하기
        /// </summary>
        /// <param name="element">UI 엘리먼트</param>
        /// <returns>추가 인덱스</returns>
        public override int Add(UIElement element)
        {
            CellPaddingGrid.ApplyMargin(this.customGrid, element);

            return base.Add(element);
        }

        #endregion
        #region 삽입하기 - Insert(index, element)

        /// <summary>
        /// 삽입하기
        /// </summary>
        /// <param name="index">인덱스</param>
        /// <param name="element">UI 엘리먼트</param>
        public override void Insert(int index, UIElement element)
        {
            CellPaddingGrid.ApplyMargin(this.customGrid, element);

            base.Insert(index, element);
        }

        #endregion
    }
}